/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    routines for relative error calculation
!******************************************************************************/

float srelerr(float a, float b)
{
  return (a-b)/a;
}

double drelerr(double a, double b)
{
  return (a-b)/a;
}

float crelerr(MKL_Complex8 a, MKL_Complex8 b)
{
  float re,im;

  re=(a.real-b.real)/a.real;
  im=(a.imag-b.imag)/a.imag;

  if(re>im) return re;
  return im;
}

double zrelerr(MKL_Complex16 a, MKL_Complex16 b)
{
  double re,im;

  re=(a.real-b.real)/a.real;
  im=(a.imag-b.imag)/a.imag;

  if(re>im) return re;
  return im;
}
