/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAtan  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex8 cA[10],cB[10],cB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  cA[0].real=-10000.0000;cA[0].imag=10000.0000;
  cA[1].real=-7777.7778;cA[1].imag=7777.7778;
  cA[2].real=-5555.5557;cA[2].imag=5555.5557;
  cA[3].real=-3333.3333;cA[3].imag=3333.3333;
  cA[4].real=-1111.1111;cA[4].imag=1111.1111;
  cA[5].real=1111.1111;cA[5].imag=-1111.1111;
  cA[6].real=3333.3333;cA[6].imag=-3333.3333;
  cA[7].real=5555.5557;cA[7].imag=-5555.5557;
  cA[8].real=7777.7778;cA[8].imag=-7777.7778;
  cA[9].real=10000.0000;cA[9].imag=-10000.0000;
  cB[0].real=-1.5707463267948132e+000;cB[0].imag=4.9999998736893758e-005;
  cB[1].real=-1.5707320410808823e+000;cB[1].imag=6.4285712142009288e-005;
  cB[2].real=-1.5707063267961685e+000;cB[2].imag=9.0000001364387572e-005;
  cB[3].real=-1.5706463267889845e+000;cB[3].imag=1.4999999257270247e-004;
  cB[4].real=-1.5703463267231603e+000;cB[4].imag=4.4999993406236172e-004;
  cB[5].real=1.5703463267231603e+000;cB[5].imag=-4.4999993406236172e-004;
  cB[6].real=1.5706463267889845e+000;cB[6].imag=-1.4999999257270247e-004;
  cB[7].real=1.5707063267961685e+000;cB[7].imag=-9.0000001364387572e-005;
  cB[8].real=1.5707320410808823e+000;cB[8].imag=-6.4285712142009288e-005;
  cB[9].real=1.5707463267948132e+000;cB[9].imag=-4.9999998736893758e-005;

  vcAtan(vec_len,cA,cB1);

  printf("vcAtan test/example program\n\n");
  printf("           Argument                           vcAtan\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .4f %+.4f*i      % .10f % +.10f*i\n",cA[i].real,cA[i].imag,cB1[i].real,cB1[i].imag);
    CurRMS=crelerr(cB[i],cB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
