/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcMulByConj  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex8 cA[10],cB[10],cB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  cA[0].real=-100.0000;cA[0].imag=100.0000;
  cA[1].real=-77.7777;cA[1].imag=77.7777;
  cA[2].real=-55.5555;cA[2].imag=55.5555;
  cA[3].real=-33.3333;cA[3].imag=33.3333;
  cA[4].real=-11.1111;cA[4].imag=11.1111;
  cA[5].real=11.1111;cA[5].imag=-11.1111;
  cA[6].real=33.3333;cA[6].imag=-33.3333;
  cA[7].real=55.5555;cA[7].imag=-55.5555;
  cA[8].real=77.7777;cA[8].imag=-77.7777;
  cA[9].real=100.0000;cA[9].imag=-100.0000;
  cB[0].real=2.0000000000000000e+004;cB[0].imag=0.0000000000000000e+000;
  cB[1].real=1.2098741959948209e+004;cB[1].imag=0.0000000000000000e+000;
  cB[2].real=6.1728271672816772e+003;cB[2].imag=0.0000000000000000e+000;
  cB[3].real=2.2222179836717260e+003;cB[3].imag=0.0000000000000000e+000;
  cB[4].real=2.4691309516836372e+002;cB[4].imag=0.0000000000000000e+000;
  cB[5].real=2.4691309516836372e+002;cB[5].imag=0.0000000000000000e+000;
  cB[6].real=2.2222179836717260e+003;cB[6].imag=0.0000000000000000e+000;
  cB[7].real=6.1728271672816772e+003;cB[7].imag=0.0000000000000000e+000;
  cB[8].real=1.2098741959948209e+004;cB[8].imag=0.0000000000000000e+000;
  cB[9].real=2.0000000000000000e+004;cB[9].imag=0.0000000000000000e+000;

  vcMulByConj(vec_len,cA,cA,cB1);

  printf("vcMulByConj test/example program\n\n");
  printf("           Arguments                           vcMulByConj\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .2f %+.2f*i   % .2f %+.2f*i      % .2f % +.2f*i\n",cA[i].real,cA[i].imag,cA[i].real,cA[i].imag,cB1[i].real,cB1[i].imag);
    CurRMS=crelerr(cB[i],cB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
