/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdAbs  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  double dA[10],dB[10],dB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  dA[0]=-1000.0000;
  dA[1]=-777.7777;
  dA[2]=-555.5555;
  dA[3]=-333.3333;
  dA[4]=-111.1111;
  dA[5]=111.1111;
  dA[6]=333.3333;
  dA[7]=555.5555;
  dA[8]=777.7777;
  dA[9]=1000.0000;
  dB[0]=1.0000000000000000e+003;
  dB[1]=7.7777769999999998e+002;
  dB[2]=5.5555550000000005e+002;
  dB[3]=3.3333330000000001e+002;
  dB[4]=1.1111109999999999e+002;
  dB[5]=1.1111109999999999e+002;
  dB[6]=3.3333330000000001e+002;
  dB[7]=5.5555550000000005e+002;
  dB[8]=7.7777769999999998e+002;
  dB[9]=1.0000000000000000e+003;

  vdAbs(vec_len,dA,dB1);

  printf("vdAbs test/example program\n\n");
  printf("           Argument                     vdAbs\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",dA[i],dB1[i]);
    CurRMS=drelerr(dB[i],dB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-14) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
