/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdAcosh  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  double dA[10],dB[10],dB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  dA[0]=3.5000;
  dA[1]=1114.2222;
  dA[2]=2224.9444;
  dA[3]=3335.6666;
  dA[4]=4446.3888;
  dA[5]=5557.1111;
  dA[6]=6667.8333;
  dA[7]=7778.5555;
  dA[8]=8889.2777;
  dA[9]=10000.0000;
  dB[0]=1.9248473002384139e+000;
  dB[1]=7.7090588411869394e+000;
  dB[2]=8.4006343355828150e+000;
  dB[3]=8.8055749765277476e+000;
  dB[4]=9.0929947080081401e+000;
  dB[5]=9.3159808383464178e+000;
  dB[6]=9.4981974184950921e+000;
  dB[7]=9.6522731079815856e+000;
  dB[8]=9.7857482540093379e+000;
  dB[9]=9.9034875500361288e+000;

  vdAcosh(vec_len,dA,dB1);

  printf("vdAcosh test/example program\n\n");
  printf("           Argument                     vdAcosh\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",dA[i],dB1[i]);
    CurRMS=drelerr(dB[i],dB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-14) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
