/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdCbrt  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  double dA[10],dB[10],dB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  dA[0]=0.0000;
  dA[1]=1111.1111;
  dA[2]=2222.2222;
  dA[3]=3333.3333;
  dA[4]=4444.4444;
  dA[5]=5555.5555;
  dA[6]=6666.6666;
  dA[7]=7777.7777;
  dA[8]=8888.8888;
  dA[9]=10000.0000;
  dB[0]=0.0000000000000000e+000;
  dB[1]=1.0357441651988058e+001;
  dB[2]=1.3049558760397682e+001;
  dB[3]=1.4938015772063830e+001;
  dB[4]=1.6441413774065087e+001;
  dB[5]=1.7710976094006931e+001;
  dB[6]=1.8820720514884833e+001;
  dB[7]=1.9813073109833521e+001;
  dB[8]=2.0714883303976116e+001;
  dB[9]=2.1544346900318835e+001;

  vdCbrt(vec_len,dA,dB1);

  printf("vdCbrt test/example program\n\n");
  printf("           Argument                     vdCbrt\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",dA[i],dB1[i]);
    CurRMS=drelerr(dB[i],dB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-14) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
