/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdErfcInv  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  double dA[10],dB[10],dB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  dA[0]=0.0001;
  dA[1]=0.2223;
  dA[2]=0.4445;
  dA[3]=0.6667;
  dA[4]=0.8889;
  dA[5]=1.1111;
  dA[6]=1.3333;
  dA[7]=1.5555;
  dA[8]=1.7777;
  dA[9]=1.9999;
  dB[0]= 2.75106390571206e+00;
  dB[1]= 8.62977894549183e-01;
  dB[2]= 5.40665442069956e-01;
  dB[3]= 3.04537782171818e-01;
  dB[4]= 9.87801562131105e-02;
  dB[5]=-9.87801562131105e-02;
  dB[6]=-3.04537782171818e-01;
  dB[7]=-5.40665442069956e-01;
  dB[8]=-8.62977894549183e-01;
  dB[9]=-2.75106390571206e+00;

  vdErfcInv(vec_len,dA,dB1);

  printf("vdErfcInv test/example program\n\n");
  printf("           Argument                     vdErfcInv\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",dA[i],dB1[i]);
    CurRMS=drelerr(dB[i],dB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-14) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
