/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAcos  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=-0.9000;
  fA[1]=-0.7000;
  fA[2]=-0.5000;
  fA[3]=-0.2999;
  fA[4]=-0.0999;
  fA[5]=0.0999;
  fA[6]=0.3000;
  fA[7]=0.5000;
  fA[8]=0.7000;
  fA[9]=0.9000;
  fB[0]=2.6905657870965607e+000;
  fB[1]=2.3461938067130106e+000;
  fB[2]=2.0943951023931957e+000;
  fB[3]=1.8753841491558372e+000;
  fB[4]=1.6708632444786764e+000;
  fB[5]=1.4707294091111169e+000;
  fB[6]=1.2661036602829701e+000;
  fB[7]=1.0471975511965979e+000;
  fB[8]=7.9539884687678286e-001;
  fB[9]=4.5102686649323265e-001;

  vsAcos(vec_len,fA,fB1);

  printf("vsAcos test/example program\n\n");
  printf("           Argument                     vsAcos\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
