/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAcosh  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=3.5000;
  fA[1]=1114.2222;
  fA[2]=2224.9443;
  fA[3]=3335.6665;
  fA[4]=4446.3887;
  fA[5]=5557.1113;
  fA[6]=6667.8335;
  fA[7]=7778.5557;
  fA[8]=8889.2773;
  fA[9]=10000.0000;
  fB[0]=1.9248473002384139e+000;
  fB[1]=7.7090588124392951e+000;
  fB[2]=8.4006343067899572e+000;
  fB[3]=8.8055749477197853e+000;
  fB[4]=9.0929946791926213e+000;
  fB[5]=9.3159808793974239e+000;
  fB[6]=9.4981974479040083e+000;
  fB[7]=9.6522731290732260e+000;
  fB[8]=9.7857482139329655e+000;
  fB[9]=9.9034875500361288e+000;

  vsAcosh(vec_len,fA,fB1);

  printf("vsAcosh test/example program\n\n");
  printf("           Argument                     vsAcosh\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
