/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAsinh  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=3.0000;
  fA[1]=1113.7777;
  fA[2]=2224.5554;
  fA[3]=3335.3333;
  fA[4]=4446.1113;
  fA[5]=5556.8887;
  fA[6]=6667.6665;
  fA[7]=7778.4443;
  fA[8]=8889.2227;
  fA[9]=10000.0000;
  fB[0]=1.8184464592320668e+000;
  fB[1]=7.7086602404420574e+000;
  fB[2]=8.4004595944431433e+000;
  fB[3]=8.8054750820135883e+000;
  fB[4]=9.0929323274814546e+000;
  fB[5]=9.3159408278816027e+000;
  fB[6]=9.4981724143920001e+000;
  fB[7]=9.6522588250499251e+000;
  fB[8]=9.7857420681667548e+000;
  fB[9]=9.9034875550361274e+000;

  vsAsinh(vec_len,fA,fB1);

  printf("vsAsinh test/example program\n\n");
  printf("           Argument                     vsAsinh\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
