/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsCdfNorm  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=-8.0000;
  fA[1]=-6.5555;
  fA[2]=-5.1111;
  fA[3]=-3.6666;
  fA[4]=-2.2222;
  fA[5]=-0.7777;
  fA[6]=0.6666;
  fA[7]=2.1111;
  fA[8]=3.5555;
  fA[9]=5.0000;
  fB[0]=6.22096057427178e-16;
  fB[1]=2.77278689399088e-11;
  fB[2]=1.60144022698396e-07;
  fB[3]=1.22898417236556e-04;
  fB[4]=1.31348990439007e-02;
  fB[5]=2.18372944048033e-01;
  fB[6]=7.47486161912039e-01;
  fB[7]=9.82618139490682e-01;
  fB[8]=9.99811369549446e-01;
  fB[9]=9.99999713348428e-01;

  vsCdfNorm(vec_len,fA,fB1);

  printf("vsCdfNorm test/example program\n\n");
  printf("           Argument                     vsCdfNorm\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
