/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsErfInv  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=0.0100;
  fA[1]=0.1188;
  fA[2]=0.2277;
  fA[3]=0.3366;
  fA[4]=0.4455;
  fA[5]=0.5544;
  fA[6]=0.6633;
  fA[7]=0.7722;
  fA[8]=0.8811;
  fA[9]=0.9900;
  fB[0]=8.8625010828478849e-003;
  fB[1]=1.0567581773310304e-001;
  fB[2]=2.0461386744486909e-001;
  fB[3]=3.0774969489332055e-001;
  fB[4]=4.1792164448362745e-001;
  fB[5]=5.3936055346528722e-001;
  fB[6]=6.7932171511922290e-001;
  fB[7]=8.5280283305887006e-001;
  fB[8]=1.1026675020579724e+000;
  fB[9]=1.8213866009002777e+000;

  vsErfInv(vec_len,fA,fB1);

  printf("vsErfInv test/example program\n\n");
  printf("           Argument                     vsErfInv\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
