/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsModf  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10],fB2[10],fB3[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=-2.0000;
  fA[1]=-1.5555;
  fA[2]=-1.1111;
  fA[3]=-0.6666;
  fA[4]=-0.2222;
  fA[5]=0.2222;
  fA[6]=0.6666;
  fA[7]=1.1111;
  fA[8]=1.5555;
  fA[9]=2.0000;
  fB[0]=0.0000000000000000e+000;
  fB[1]=-5.5550003051757813e-001;
  fB[2]=-1.1109995841979980e-001;
  fB[3]=-6.6659998893737793e-001;
  fB[4]=-2.2220000624656677e-001;
  fB[5]=2.2220000624656677e-001;
  fB[6]=6.6659998893737793e-001;
  fB[7]=1.1109995841979980e-001;
  fB[8]=5.5550003051757813e-001;
  fB[9]=0.0000000000000000e+000;
  fB2[0]=-2.0000000000000000e+000;
  fB2[1]=-1.0000000000000000e+000;
  fB2[2]=-1.0000000000000000e+000;
  fB2[3]=0.0000000000000000e+000;
  fB2[4]=0.0000000000000000e+000;
  fB2[5]=0.0000000000000000e+000;
  fB2[6]=0.0000000000000000e+000;
  fB2[7]=1.0000000000000000e+000;
  fB2[8]=1.0000000000000000e+000;
  fB2[9]=2.0000000000000000e+000;

  vsModf(vec_len,fA,fB1,fB3);

  printf("vsModf test/example program\n\n");
  printf("           Argument                            vsModf\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e % 25.14e\n",fA[i],fB1[i],fB3[i]);
    CurRMS=srelerr(fB[i],fB3[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
    CurRMS=srelerr(fB2[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
