/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsTanh  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  float fA[10],fB[10],fB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  fA[0]=-10.0000;
  fA[1]=-7.7777;
  fA[2]=-5.5555;
  fA[3]=-3.3333;
  fA[4]=-1.1111;
  fA[5]=1.1111;
  fA[6]=3.3333;
  fA[7]=5.5555;
  fA[8]=7.7777;
  fA[9]=10.0000;
  fB[0]=-9.9999999587769273e-001;
  fB[1]=-9.9999964892041093e-001;
  fB[2]=-9.9997010645022300e-001;
  fB[3]=-9.9745779879202223e-001;
  fB[4]=-8.0445086500837071e-001;
  fB[5]=8.0445086500837071e-001;
  fB[6]=9.9745779879202223e-001;
  fB[7]=9.9997010645022300e-001;
  fB[8]=9.9999964892041093e-001;
  fB[9]=9.9999999587769273e-001;

  vsTanh(vec_len,fA,fB1);

  printf("vsTanh test/example program\n\n");
  printf("           Argument                     vsTanh\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("% 25.14f % 25.14e\n",fA[i],fB1[i]);
    CurRMS=srelerr(fB[i],fB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
