/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vzCIS  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  double dA[10];
  MKL_Complex16 zB[10],zB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  dA[0]=-10000.0000;
  dA[1]=-7777.7777;
  dA[2]=-5555.5555;
  dA[3]=-3333.3333;
  dA[4]=-1111.1111;
  dA[5]=1111.1111;
  dA[6]=3333.3333;
  dA[7]=5555.5555;
  dA[8]=7777.7777;
  dA[9]=10000.0000;
  zB[0].real=-9.5215536825901481e-001;zB[0].imag=3.0561438888825215e-001;
  zB[1].real=6.9259906263181004e-001;zB[1].imag=7.2132276994528466e-001;
  zB[2].real=3.4393830299014322e-001;zB[2].imag=-9.3899224902885137e-001;
  zB[3].real=-9.9464921859866051e-001;zB[3].imag=1.0330988307550266e-001;
  zB[4].real=5.2957287328011915e-001;zB[4].imag=8.4826444690664649e-001;
  zB[5].real=5.2957287328011915e-001;zB[5].imag=-8.4826444690664649e-001;
  zB[6].real=-9.9464921859866051e-001;zB[6].imag=-1.0330988307550266e-001;
  zB[7].real=3.4393830299014322e-001;zB[7].imag=9.3899224902885137e-001;
  zB[8].real=6.9259906263181004e-001;zB[8].imag=-7.2132276994528466e-001;
  zB[9].real=-9.5215536825901481e-001;zB[9].imag=-3.0561438888825215e-001;

  vzCIS(vec_len,dA,zB1);

  printf("vzCIS test/example program\n\n");
  printf("           Argument                           vzCIS\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .4f      % .10f % +.10f*i\n",dA[i],zB[i].real,zB[i].imag);
    CurRMS=zrelerr(zB[i],zB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
