/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vzConj  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex16 zA[10],zB[10],zB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  zA[0].real=-100.0000;zA[0].imag=100.0000;
  zA[1].real=-77.7777;zA[1].imag=77.7777;
  zA[2].real=-55.5555;zA[2].imag=55.5555;
  zA[3].real=-33.3333;zA[3].imag=33.3333;
  zA[4].real=-11.1111;zA[4].imag=11.1111;
  zA[5].real=11.1111;zA[5].imag=-11.1111;
  zA[6].real=33.3333;zA[6].imag=-33.3333;
  zA[7].real=55.5555;zA[7].imag=-55.5555;
  zA[8].real=77.7777;zA[8].imag=-77.7777;
  zA[9].real=100.0000;zA[9].imag=-100.0000;
  zB[0].real=-1.0000000000000000e+002;zB[0].imag=-1.0000000000000000e+002;
  zB[1].real=-7.7777699999999996e+001;zB[1].imag=-7.7777699999999996e+001;
  zB[2].real=-5.5555500000000002e+001;zB[2].imag=-5.5555500000000002e+001;
  zB[3].real=-3.3333300000000001e+001;zB[3].imag=-3.3333300000000001e+001;
  zB[4].real=-1.1111100000000000e+001;zB[4].imag=-1.1111100000000000e+001;
  zB[5].real=1.1111100000000000e+001;zB[5].imag=1.1111100000000000e+001;
  zB[6].real=3.3333300000000001e+001;zB[6].imag=3.3333300000000001e+001;
  zB[7].real=5.5555500000000002e+001;zB[7].imag=5.5555500000000002e+001;
  zB[8].real=7.7777699999999996e+001;zB[8].imag=7.7777699999999996e+001;
  zB[9].real=1.0000000000000000e+002;zB[9].imag=1.0000000000000000e+002;

  vzConj(vec_len,zA,zB1);

  printf("vzConj test/example program\n\n");
  printf("           Argument                           vzConj\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .4f %+.4f*i      % .10f % +.10f*i\n",zA[i].real,zA[i].imag,zB1[i].real,zB1[i].imag);
    CurRMS=zrelerr(zB[i],zB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
