/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vzMul  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex16 zA[10],zB[10],zB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  zA[0].real=-100.0000;zA[0].imag=100.0000;
  zA[1].real=-77.7777;zA[1].imag=77.7777;
  zA[2].real=-55.5555;zA[2].imag=55.5555;
  zA[3].real=-33.3333;zA[3].imag=33.3333;
  zA[4].real=-11.1111;zA[4].imag=11.1111;
  zA[5].real=11.1111;zA[5].imag=-11.1111;
  zA[6].real=33.3333;zA[6].imag=-33.3333;
  zA[7].real=55.5555;zA[7].imag=-55.5555;
  zA[8].real=77.7777;zA[8].imag=-77.7777;
  zA[9].real=100.0000;zA[9].imag=-100.0000;
  zB[0].real=0.0000000000000000e+000;zB[0].imag=-2.0000000000000000e+004;
  zB[1].real=0.0000000000000000e+000;zB[1].imag=-1.2098741234579998e+004;
  zB[2].real=0.0000000000000000e+000;zB[2].imag=-6.1728271605000009e+003;
  zB[3].real=0.0000000000000000e+000;zB[3].imag=-2.2222177777800002e+003;
  zB[4].real=0.0000000000000000e+000;zB[4].imag=-2.4691308642000001e+002;
  zB[5].real=0.0000000000000000e+000;zB[5].imag=-2.4691308642000001e+002;
  zB[6].real=0.0000000000000000e+000;zB[6].imag=-2.2222177777800002e+003;
  zB[7].real=0.0000000000000000e+000;zB[7].imag=-6.1728271605000009e+003;
  zB[8].real=0.0000000000000000e+000;zB[8].imag=-1.2098741234579998e+004;
  zB[9].real=0.0000000000000000e+000;zB[9].imag=-2.0000000000000000e+004;

  vzMul(vec_len,zA,zA,zB1);

  printf("vzMul test/example program\n\n");
  printf("           Arguments                           vzMul\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .2f %+.2f*i   % .2f %+.2f*i      % .2f % +.2f*i\n",zA[i].real,zA[i].imag,zA[i].real,zA[i].imag,zB1[i].real,zB1[i].imag);
    CurRMS=zrelerr(zB[i],zB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
