/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vzSinh  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex16 zA[10],zB[10],zB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  zA[0].real=-7.0000;zA[0].imag=7.0000;
  zA[1].real=-5.4444;zA[1].imag=5.4444;
  zA[2].real=-3.8888;zA[2].imag=3.8888;
  zA[3].real=-2.3333;zA[3].imag=2.3333;
  zA[4].real=-0.7777;zA[4].imag=0.7777;
  zA[5].real=0.7777;zA[5].imag=-0.7777;
  zA[6].real=2.3333;zA[6].imag=-2.3333;
  zA[7].real=3.8888;zA[7].imag=-3.8888;
  zA[8].real=5.4444;zA[8].imag=-5.4444;
  zA[9].real=7.0000;zA[9].imag=-7.0000;
  zB[0].real=-4.1337676142848187e+002;zB[0].imag=3.6023694394619349e+002;
  zB[1].real=-7.7348104204023088e+001;zB[1].imag=-8.6084653219059518e+001;
  zB[2].real=1.7911235047375367e+001;zB[2].imag=-1.6606765833296961e+001;
  zB[3].real=3.5279032191119786e+000;zB[3].imag=3.7633805209492461e+000;
  zB[4].real=-6.1170599172912610e-001;zB[4].imag=9.2473746870188400e-001;
  zB[5].real=6.1170599172912610e-001;zB[5].imag=-9.2473746870188400e-001;
  zB[6].real=-3.5279032191119786e+000;zB[6].imag=-3.7633805209492461e+000;
  zB[7].real=-1.7911235047375367e+001;zB[7].imag=1.6606765833296961e+001;
  zB[8].real=7.7348104204023088e+001;zB[8].imag=8.6084653219059518e+001;
  zB[9].real=4.1337676142848187e+002;zB[9].imag=-3.6023694394619349e+002;

  vzSinh(vec_len,zA,zB1);

  printf("vzSinh test/example program\n\n");
  printf("           Argument                           vzSinh\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .4f %+.4f*i      % .10f % +.10f*i\n",zA[i].real,zA[i].imag,zB1[i].real,zB1[i].imag);
    CurRMS=zrelerr(zB[i],zB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-14) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
