/*******************************************************************************
!                             INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vzSqrt  Example Program Text
!******************************************************************************/

#include <stdio.h>
#include "mkl_vml.h"

#include "_rms.h"

int main()
{
  MKL_Complex16 zA[10],zB[10],zB1[10];
  float CurRMS,MaxRMS=0.0;

  MKL_INT i=0,vec_len=10;

  zA[0].real=0.0000;zA[0].imag=10000.0000;
  zA[1].real=1111.1111;zA[1].imag=8888.8888;
  zA[2].real=2222.2222;zA[2].imag=7777.7777;
  zA[3].real=3333.3333;zA[3].imag=6666.6666;
  zA[4].real=4444.4444;zA[4].imag=5555.5555;
  zA[5].real=5555.5555;zA[5].imag=4444.4444;
  zA[6].real=6666.6666;zA[6].imag=3333.3333;
  zA[7].real=7777.7777;zA[7].imag=2222.2222;
  zA[8].real=8888.8888;zA[8].imag=1111.1111;
  zA[9].real=10000.0000;zA[9].imag=0.0000;
  zB[0].real=7.0710678118654755e+001;zB[0].imag=7.0710678118654755e+001;
  zB[1].real=7.0954827796266002e+001;zB[1].imag=6.2637660297921109e+001;
  zB[2].real=7.1802622191669840e+001;zB[2].imag=5.4160819358644105e+001;
  zB[3].real=7.3440088338943667e+001;zB[3].imag=4.5388470730262000e+001;
  zB[4].real=7.6023111008727710e+001;zB[4].imag=3.6538596134024317e+001;
  zB[5].real=7.9593146422574208e+001;zB[5].imag=2.7919768219763874e+001;
  zB[6].real=8.4024479916461544e+001;zB[6].imag=1.9835489034350779e+001;
  zB[7].real=8.9069603701822302e+001;zB[7].imag=1.2474638415588544e+001;
  zB[8].real=9.4464154246982829e+001;zB[8].imag=5.8811255383440271e+000;
  zB[9].real=1.0000000000000000e+002;zB[9].imag=0.0000000000000000e+000;

  vzSqrt(vec_len,zA,zB1);

  printf("vzSqrt test/example program\n\n");
  printf("           Argument                           vzSqrt\n");
  printf("===============================================================================\n");
  for(i=0;i<10;i++) {
    printf("   % .4f %+.4f*i      % .10f % +.10f*i\n",zA[i].real,zA[i].imag,zB1[i].real,zB1[i].imag);
    CurRMS=zrelerr(zB[i],zB1[i]);
    if(CurRMS>MaxRMS) MaxRMS=CurRMS;
  }
  printf("\n");
  if(MaxRMS>=1e-5) {
    printf("Error! Relative accuracy is %.16f\n",MaxRMS);
    return 1;
  }
  else {
    printf("Relative accuracy is %.16f\n",MaxRMS);
  }

  return 0;
}
