!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAbs  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-1000.0000,1000.0000)
      cA( 2)=(-777.7777,777.7777)
      cA( 3)=(-555.5555,555.5555)
      cA( 4)=(-333.3333,333.3333)
      cA( 5)=(-111.1111,111.1111)
      cA( 6)=(111.1111,-111.1111)
      cA( 7)=(333.3333,-333.3333)
      cA( 8)=(555.5555,-555.5555)
      cA( 9)=(777.7777,-777.7777)
      cA(10)=(1000.0000,-1000.0000)
      fB( 1)=1.4142135623730951e+003
      fB( 2)=1.0999437859382454e+003
      fB( 3)=7.8567409582014136e+002
      fB( 4)=4.7140449201878312e+002
      fB( 5)=1.5713482347986556e+002
      fB( 6)=1.5713482347986556e+002
      fB( 7)=4.7140449201878312e+002
      fB( 8)=7.8567409582014136e+002
      fB( 9)=1.0999437859382454e+003
      fB(10)=1.4142135623730951e+003

      call VCABS(vec_len,cA,fB1)

      print *,"vcAbs test/example program"
      print *,""
      print *,"           Argument                     vcAbs"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7)
11    format(A,F25.16)

      end
