!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAcosh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(3.5000,10000.0000)
      cA( 2)=(1114.2222,8889.2773)
      cA( 3)=(2224.9443,7778.5557)
      cA( 4)=(3335.6665,6667.8335)
      cA( 5)=(4446.3887,5557.1113)
      cA( 6)=(5557.1113,4446.3887)
      cA( 7)=(6667.8335,3335.6665)
      cA( 8)=(7778.5557,2224.9443)
      cA( 9)=(8889.2773,1114.2222)
      cA(10)=(10000.0000,3.5000)
      cB( 1)=(9.9034876162861227e+000,1.5704463720321655e+000)
      cB( 2)=(9.7935427720062638e+000,1.4461021423339844e+000)
      cB( 3)=(9.6915938771298862e+000,1.2921996116638184e+000)
      cB( 4)=(9.6098742153837620e+000,1.1069388389587402e+000)
      cB( 5)=(9.5633904224721853e+000,8.9597856998443604e-001)
      cB( 6)=(9.5633904203067921e+000,6.7481774091720581e-001)
      cB( 7)=(9.6098742099898065e+000,4.6385756134986877e-001)
      cB( 8)=(9.6915938706466100e+000,2.7859675884246826e-001)
      cB( 9)=(9.7935427659692937e+000,1.2469419836997986e-001)
      cB(10)=(9.9034876112861259e+000,3.4999998752027750e-004)

      call VCACOSH(vec_len,cA,cB1)

      print *,"vcAcosh test/example program"
      print *,""
      print *,"           Argument                     vcAcosh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cB1(i)
            CurRMS=crelerr(cB(i),cB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
