!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAsin  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-1.0000,1.0000)
      cA( 2)=(-0.7777,0.7777)
      cA( 3)=(-0.5555,0.5555)
      cA( 4)=(-0.3333,0.3333)
      cA( 5)=(-0.1111,0.1111)
      cA( 6)=(0.1111,-0.1111)
      cA( 7)=(0.3333,-0.3333)
      cA( 8)=(0.5555,-0.5555)
      cA( 9)=(0.7777,-0.7777)
      cA(10)=(1.0000,-1.0000)
      cB( 1)=(-6.6623943249251527e-001,1.0612750053405762e+000)
      cB( 2)=(-6.0135587974594140e-001,8.4060454368591309e-001)
      cB( 3)=(-4.8944078583553818e-001,5.9386557340621948e-001)
      cB( 4)=(-3.1990734164088330e-001,3.4427276253700256e-001)
      cB( 5)=(-1.1063789073495189e-001,1.1155195534229279e-001)
      cB( 6)=(1.1063789073495189e-001,-1.1155195534229279e-001)
      cB( 7)=(3.1990734164088330e-001,-3.4427276253700256e-001)
      cB( 8)=(4.8944078583553818e-001,-5.9386557340621948e-001)
      cB( 9)=(6.0135587974594140e-001,-8.4060454368591309e-001)
      cB(10)=(6.6623943249251527e-001,-1.0612750053405762e+000)

      call VCASIN(vec_len,cA,cB1)

      print *,"vcAsin test/example program"
      print *,""
      print *,"           Argument                     vcAsin"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cB1(i)
            CurRMS=crelerr(cB(i),cB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
