!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAtanh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(0.7500,0.9000)
      cA( 2)=(0.7666,0.8833)
      cA( 3)=(0.7833,0.8666)
      cA( 4)=(0.8000,0.8500)
      cA( 5)=(0.8166,0.8333)
      cA( 6)=(0.8333,0.8166)
      cA( 7)=(0.8500,0.8000)
      cA( 8)=(0.8666,0.7833)
      cA( 9)=(0.8833,0.7666)
      cA(10)=(0.9000,0.7500)
      cB( 1)=(3.7257323907975143e-001,8.8743013143539429e-001)
      cB( 2)=(3.8548667482649812e-001,8.8805592060089111e-001)
      cB( 3)=(3.9865922844057755e-001,8.8905519247055054e-001)
      cB( 4)=(4.1200697096525207e-001,8.9044255018234253e-001)
      cB( 5)=(4.2558004817630984e-001,8.9211910963058472e-001)
      cB( 6)=(4.3940256872758254e-001,8.9423400163650513e-001)
      cB( 7)=(4.5338331929830056e-001,8.9679872989654541e-001)
      cB( 8)=(4.6758174531596247e-001,8.9971578121185303e-001)
      cB( 9)=(4.8200889281307913e-001,9.0314799547195435e-001)
      cB(10)=(4.9656447251629632e-001,9.0710288286209106e-001)

      call VCATANH(vec_len,cA,cB1)

      print *,"vcAtanh test/example program"
      print *,""
      print *,"           Argument                     vcAtanh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cB1(i)
            CurRMS=crelerr(cB(i),cB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
