!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcCosh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-7.0000,7.0000)
      cA( 2)=(-5.4444,5.4444)
      cA( 3)=(-3.8888,3.8888)
      cA( 4)=(-2.3333,2.3333)
      cA( 5)=(-0.7777,0.7777)
      cA( 6)=(0.7777,-0.7777)
      cA( 7)=(2.3333,-2.3333)
      cA( 8)=(3.8888,-3.8888)
      cA( 9)=(5.4444,-5.4444)
      cA(10)=(7.0000,-7.0000)
      cB( 1)=(4.1337744889835142e+002,-3.6023635864257812e+002)
      cB( 2)=(7.7350964654925434e+001,8.6081436157226562e+001)
      cB( 3)=(-1.7926251426561219e+001,1.6592855453491211e+001)
      cB( 4)=(-3.5948881195262539e+000,-3.6932568550109863e+000)
      cB( 5)=(9.3908576577846370e-001,-6.0235971212387085e-001)
      cB( 6)=(9.3908576577846370e-001,-6.0235971212387085e-001)
      cB( 7)=(-3.5948881195262539e+000,-3.6932568550109863e+000)
      cB( 8)=(-1.7926251426561219e+001,1.6592855453491211e+001)
      cB( 9)=(7.7350964654925434e+001,8.6081436157226562e+001)
      cB(10)=(4.1337744889835142e+002,-3.6023635864257812e+002)

      call VCCOSH(vec_len,cA,cB1)

      print *,"vcCosh test/example program"
      print *,""
      print *,"           Argument                     vcCosh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cB1(i)
            CurRMS=crelerr(cB(i),cB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
