!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcSqrt  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(0.0000,10000.0000)
      cA( 2)=(1111.1111,8888.8887)
      cA( 3)=(2222.2222,7777.7778)
      cA( 4)=(3333.3333,6666.6665)
      cA( 5)=(4444.4443,5555.5557)
      cA( 6)=(5555.5557,4444.4443)
      cA( 7)=(6666.6665,3333.3333)
      cA( 8)=(7777.7778,2222.2222)
      cA( 9)=(8888.8887,1111.1111)
      cA(10)=(10000.0000,0.0000)
      cB( 1)=(7.0710678118654755e+001,7.0710678100585937e+001)
      cB( 2)=(7.0954827284892332e+001,6.2637660980224609e+001)
      cB( 3)=(7.1802622491520651e+001,5.4160820007324219e+001)
      cB( 4)=(7.3440087809658650e+001,4.5388469696044922e+001)
      cB( 5)=(7.6023111087747310e+001,3.6538597106933594e+001)
      cB( 6)=(7.9593147214584178e+001,2.7919767379760742e+001)
      cB( 7)=(8.4024479310894492e+001,1.9835489273071289e+001)
      cB( 8)=(8.9069604404033797e+001,1.2474637985229492e+001)
      cB( 9)=(9.4464153566176705e+001,5.8811254501342773e+000)
      cB(10)=(1.0000000000000000e+002,0.0000000000000000e+000)

      call VCSQRT(vec_len,cA,cB1)

      print *,"vcSqrt test/example program"
      print *,""
      print *,"           Argument                     vcSqrt"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cB1(i)
            CurRMS=crelerr(cB(i),cB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
