!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdAcos  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-0.9000d+000
      dA( 2)=-0.7000d+000
      dA( 3)=-0.5000d+000
      dA( 4)=-0.2999d+000
      dA( 5)=-0.0999d+000
      dA( 6)=0.0999d+000
      dA( 7)=0.3000d+000
      dA( 8)=0.5000d+000
      dA( 9)=0.7000d+000
      dA(10)=0.9000d+000
      dB( 1)=2.6905658417935308d+000
      dB( 2)=2.3461938234056494d+000
      dB( 3)=2.0943951023931957d+000
      dB( 4)=1.8753841540543150d+000
      dB( 5)=1.6708632446823510d+000
      dB( 6)=1.4707294089074423d+000
      dB( 7)=1.2661036727794992d+000
      dB( 8)=1.0471975511965979d+000
      dB( 9)=7.9539883018414359d-001
      dB(10)=4.5102681179626236d-001

      call VDACOS(vec_len,dA,dB1)

      print *,"vdAcos test/example program"
      print *,""
      print *,"           Argument                     vdAcos"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
