!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdAcosh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=3.5000d+000
      dA( 2)=1114.2222d+000
      dA( 3)=2224.9444d+000
      dA( 4)=3335.6666d+000
      dA( 5)=4446.3888d+000
      dA( 6)=5557.1111d+000
      dA( 7)=6667.8333d+000
      dA( 8)=7778.5555d+000
      dA( 9)=8889.2777d+000
      dA(10)=10000.0000d+000
      dB( 1)=1.9248473002384139d+000
      dB( 2)=7.7090588411869394d+000
      dB( 3)=8.4006343355828150d+000
      dB( 4)=8.8055749765277476d+000
      dB( 5)=9.0929947080081401d+000
      dB( 6)=9.3159808383464178d+000
      dB( 7)=9.4981974184950921d+000
      dB( 8)=9.6522731079815856d+000
      dB( 9)=9.7857482540093379d+000
      dB(10)=9.9034875500361288d+000

      call VDACOSH(vec_len,dA,dB1)

      print *,"vdAcosh test/example program"
      print *,""
      print *,"           Argument                     vdAcosh"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
