!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdErf  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=1.0000d+000
      dA( 2)=1.3333d+000
      dA( 3)=1.6666d+000
      dA( 4)=2.0000d+000
      dA( 5)=2.3333d+000
      dA( 6)=2.6666d+000
      dA( 7)=3.0000d+000
      dA( 8)=3.3333d+000
      dA( 9)=3.6666d+000
      dA(10)=4.0000d+000
      dB( 1)=8.4270079294971489d-001
      dB( 2)=9.4064720388873690d-001
      dB( 3)=9.8157319677988275d-001
      dB( 4)=9.9532226501895271d-001
      dB( 5)=9.9903240904150581d-001
      dB( 6)=9.9983749776098785d-001
      dB( 7)=9.9997790950300136d-001
      dB( 8)=9.9999757097033093d-001
      dB( 9)=9.9999978439673953d-001
      dB(10)=9.9999998458274209d-001

      call VDERF(vec_len,dA,dB1)

      print *,"vdErf test/example program"
      print *,""
      print *,"           Argument                     vdErf"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
