!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdExp  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-17.0000d+000
      dA( 2)=-13.1111d+000
      dA( 3)=-9.2222d+000
      dA( 4)=-5.3333d+000
      dA( 5)=-1.4444d+000
      dA( 6)=2.4444d+000
      dA( 7)=6.3333d+000
      dA( 8)=10.2222d+000
      dA( 9)=14.1111d+000
      dA(10)=18.0000d+000
      dB( 1)=4.1399377187851668d-008
      dB( 2)=2.0226540961279020d-006
      dB( 3)=9.8821042017595656d-005
      dB( 4)=4.8281109281801239d-003
      dB( 5)=2.3588756664457899d-001
      dB( 6)=1.1523633344163436d+001
      dB( 7)=5.6301146947418135d+002
      dB( 8)=2.7507115619920700d+004
      dB( 9)=1.3439182871964260d+006
      dB(10)=6.5659969137330510d+007

      call VDEXP(vec_len,dA,dB1)

      print *,"vdExp test/example program"
      print *,""
      print *,"           Argument                     vdExp"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
