!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdHypot  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=1.0009d+000
      dA( 2)=1112.0008d+000
      dA( 3)=2223.0007d+000
      dA( 4)=3334.0006d+000
      dA( 5)=4445.0005d+000
      dA( 6)=5556.0004d+000
      dA( 7)=6667.0003d+000
      dA( 8)=7778.0002d+000
      dA( 9)=8889.0001d+000
      dA(10)=10000.0000d+000
      dB( 1)=1.4154863545792307d+000
      dB( 2)=1.5726066127297315d+003
      dB( 3)=3.1437977391048839d+003
      dB( 4)=4.7149888654800361d+003
      dB( 5)=6.2861799918551887d+003
      dB( 6)=7.8573711182303405d+003
      dB( 7)=9.4285622446054931d+003
      dB( 8)=1.0999753370980647d+004
      dB( 9)=1.2570944497355797d+004
      dB(10)=1.4142135623730950d+004

      call VDHYPOT(vec_len,dA,dA,dB1)

      print *,"vdHypot test/example program"
      print *,""
      print *,"                    Arguments                         ", &
     &        "     vdHypot"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
