!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vdPow  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=0.1000d+000
      dA( 2)=0.8666d+000
      dA( 3)=1.6333d+000
      dA( 4)=2.4000d+000
      dA( 5)=3.1666d+000
      dA( 6)=3.9333d+000
      dA( 7)=4.7000d+000
      dA( 8)=5.4666d+000
      dA( 9)=6.2333d+000
      dA(10)=7.0000d+000
      dB( 1)=7.9432823472428149d-001
      dB( 2)=8.8331106784443691d-001
      dB( 3)=2.2284384118803935d+000
      dB( 4)=8.1753617751846335d+000
      dB( 5)=3.8474984243761270d+001
      dB( 6)=2.1845298918747244d+002
      dB( 7)=1.4416503186448467d+003
      dB( 8)=1.0784633129292892d+004
      dB( 9)=8.9890933918204668d+004
      dB(10)=8.2354300000000000d+005

      call VDPOW(vec_len,dA,dA,dB1)

      print *,"vdPow test/example program"
      print *,""
      print *,"                   Arguments                          ", &
     &        "      vdPow"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dA(i),dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
