!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAbs  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-1000.0000
      fA( 2)=-777.7777
      fA( 3)=-555.5555
      fA( 4)=-333.3333
      fA( 5)=-111.1111
      fA( 6)=111.1111
      fA( 7)=333.3333
      fA( 8)=555.5555
      fA( 9)=777.7777
      fA(10)=1000.0000
      fB( 1)=1.0000000000000000e+003
      fB( 2)=7.7777770996093750e+002
      fB( 3)=5.5555548095703125e+002
      fB( 4)=3.3333331298828125e+002
      fB( 5)=1.1111109924316406e+002
      fB( 6)=1.1111109924316406e+002
      fB( 7)=3.3333331298828125e+002
      fB( 8)=5.5555548095703125e+002
      fB( 9)=7.7777770996093750e+002
      fB(10)=1.0000000000000000e+003

      call VSABS(vec_len,fA,fB1)

      print *,"vsAbs test/example program"
      print *,""
      print *,"           Argument                     vsAbs"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
