!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAcosh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=3.5000
      fA( 2)=1114.2222
      fA( 3)=2224.9443
      fA( 4)=3335.6665
      fA( 5)=4446.3887
      fA( 6)=5557.1113
      fA( 7)=6667.8335
      fA( 8)=7778.5557
      fA( 9)=8889.2773
      fA(10)=10000.0000
      fB( 1)=1.9248473002384139e+000
      fB( 2)=7.7090588124392951e+000
      fB( 3)=8.4006343067899572e+000
      fB( 4)=8.8055749477197853e+000
      fB( 5)=9.0929946791926213e+000
      fB( 6)=9.3159808793974239e+000
      fB( 7)=9.4981974479040083e+000
      fB( 8)=9.6522731290732260e+000
      fB( 9)=9.7857482139329655e+000
      fB(10)=9.9034875500361288e+000

      call VSACOSH(vec_len,fA,fB1)

      print *,"vsAcosh test/example program"
      print *,""
      print *,"           Argument                     vsAcosh"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
