!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsAtanh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.7500
      fA( 2)=0.7666
      fA( 3)=0.7833
      fA( 4)=0.8000
      fA( 5)=0.8166
      fA( 6)=0.8333
      fA( 7)=0.8500
      fA( 8)=0.8666
      fA( 9)=0.8833
      fA(10)=0.9000
      fB( 1)=9.7295507452765662e-001
      fB( 2)=1.0120292082224451e+000
      fB( 3)=1.0538534302966309e+000
      fB( 4)=1.0986123217818020e+000
      fB( 5)=1.1465262447609375e+000
      fB( 6)=1.1988385373069341e+000
      fB( 7)=1.2561528979046688e+000
      fB( 8)=1.3192607775232970e+000
      fB( 9)=1.3905871775267402e+000
      fB(10)=1.4722193640997716e+000

      call VSATANH(vec_len,fA,fB1)

      print *,"vsAtanh test/example program"
      print *,""
      print *,"           Argument                     vsAtanh"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
