!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsCdfNorm  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-8.0000
      fA( 2)=-6.5555
      fA( 3)=-5.1111
      fA( 4)=-3.6666
      fA( 5)=-2.2222
      fA( 6)=-0.7777
      fA( 7)=0.6666
      fA( 8)=2.1111
      fA( 9)=3.5555
      fA(10)=5.0000
      fB( 1)=6.22096057427178e-16
      fB( 2)=2.77278689399088e-11
      fB( 3)=1.60144022698396e-07
      fB( 4)=1.22898417236556e-04
      fB( 5)=1.31348990439007e-02
      fB( 6)=2.18372944048033e-01
      fB( 7)=7.47486161912039e-01
      fB( 8)=9.82618139490682e-01
      fB( 9)=9.99811369549446e-01
      fB(10)=9.99999713348428e-01

      call VSCDFNORM(vec_len,fA,fB1)

      print *,"vsCdfNorm test/example program"
      print *,""
      print *,"           Argument                     vsCdfNorm"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
