!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsErf  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=1.0000
      fA( 2)=1.3333
      fA( 3)=1.6666
      fA( 4)=2.0000
      fA( 5)=2.3333
      fA( 6)=2.6666
      fA( 7)=3.0000
      fA( 8)=3.3333
      fA( 9)=3.6666
      fA(10)=4.0000
      fB( 1)=8.4270079294971489e-001
      fB( 2)=9.4064720283376069e-001
      fB( 3)=9.8157319600357118e-001
      fB( 4)=9.9532226501895271e-001
      fB( 5)=9.9903240959575701e-001
      fB( 6)=9.9983749775079844e-001
      fB( 7)=9.9997790950300136e-001
      fB( 8)=9.9999757097224840e-001
      fB( 9)=9.9999978439672144e-001
      fB(10)=9.9999998458274209e-001

      call VSERF(vec_len,fA,fB1)

      print *,"vsErf test/example program"
      print *,""
      print *,"           Argument                     vsErf"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
