!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsErfcInv  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.0001
      fA( 2)=0.2223
      fA( 3)=0.4445
      fA( 4)=0.6667
      fA( 5)=0.8889
      fA( 6)=1.1111
      fA( 7)=1.3333
      fA( 8)=1.5555
      fA( 9)=1.7777
      fA(10)=1.9999
      fB( 1)= 2.75106391005276e+00
      fB( 2)= 8.62977907541907e-01
      fB( 3)= 5.40665442919061e-01
      fB( 4)= 3.04537776793446e-01
      fB( 5)= 9.87801723434816e-02
      fB( 6)=-9.87801190022983e-02
      fB( 7)=-3.04537776793446e-01
      fB( 8)=-5.40665478298228e-01
      fB( 9)=-8.62977796302805e-01
      fB(10)=-2.75103543790861e+00

      call VSERFCINV(vec_len,fA,fB1)

      print *,"vsErfcInv test/example program"
      print *,""
      print *,"           Argument                     vsErfcInv"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
