!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsExp  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-17.0000
      fA( 2)=-13.1111
      fA( 3)=-9.2222
      fA( 4)=-5.3333
      fA( 5)=-1.4444
      fA( 6)=2.4444
      fA( 7)=6.3333
      fA( 8)=10.2222
      fA( 9)=14.1111
      fA(10)=18.0000
      fB( 1)=4.1399377187851668e-008
      fB( 2)=2.0226536979919889e-006
      fB( 3)=9.8821003114055964e-005
      fB( 4)=4.8281103793302660e-003
      fB( 5)=2.3588757775759897e-001
      fB( 6)=1.1523634174991830e+001
      fB( 7)=5.6301153347619049e+002
      fB( 8)=2.7507126448834904e+004
      fB( 9)=1.3439185517311485e+006
      fB(10)=6.5659969137330510e+007

      call VSEXP(vec_len,fA,fB1)

      print *,"vsExp test/example program"
      print *,""
      print *,"           Argument                     vsExp"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
