!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsHypot  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=1.0009
      fA( 2)=1112.0009
      fA( 3)=2223.0007
      fA( 4)=3334.0005
      fA( 5)=4445.0005
      fA( 6)=5556.0005
      fA( 7)=6667.0005
      fA( 8)=7778.0000
      fA( 9)=8889.0000
      fA(10)=10000.0000
      fB( 1)=1.4154863971981240e+000
      fB( 2)=1.5726066897933222e+003
      fB( 3)=3.1437977849563395e+003
      fB( 4)=4.7149887074858652e+003
      fB( 5)=6.2861799752823736e+003
      fB( 6)=7.8573712430788819e+003
      fB( 7)=9.4285625108753902e+003
      fB( 8)=1.0999753088137933e+004
      fB( 9)=1.2570944355934442e+004
      fB(10)=1.4142135623730950e+004

      call VSHYPOT(vec_len,fA,fA,fB1)

      print *,"vsHypot test/example program"
      print *,""
      print *,"                    Arguments                         ", &
     &        "       vsHypot"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
