!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsLog1p  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.1000
      fA( 2)=1111.2000
      fA( 3)=2222.2998
      fA( 4)=3333.3999
      fA( 5)=4444.5000
      fA( 6)=5555.6001
      fA( 7)=6666.7002
      fA( 8)=7777.7998
      fA( 9)=8888.9004
      fA(10)=10000.0000
      fB( 1)=9.5310181158975882e-002
      fB( 2)=7.0140952708511746e+000
      fB( 3)=7.7067477697774001e+000
      fB( 4)=8.1120480028314894e+000
      fB( 5)=8.3996476275611940e+000
      fB( 6)=8.6227417069790988e+000
      fB( 7)=8.8050302811490937e+000
      fB( 8)=8.9591573385224201e+000
      fB( 9)=9.0926711237910727e+000
      fB(10)=9.2104403669765169e+000

      call VSLOG1P(vec_len,fA,fB1)

      print *,"vsLog1p test/example program"
      print *,""
      print *,"           Argument                     vsLog1p"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
