!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vsMul  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fB1(10)
      real(kind=4) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-100.0000
      fA( 2)=-77.7777
      fA( 3)=-55.5555
      fA( 4)=-33.3333
      fA( 5)=-11.1111
      fA( 6)=11.1111
      fA( 7)=33.3333
      fA( 8)=55.5555
      fA( 9)=77.7777
      fA(10)=100.0000
      fB( 1)=1.0000000000000000e+004
      fB( 2)=6.0493709799741046e+003
      fB( 3)=3.0864135836408386e+003
      fB( 4)=1.1111089918358630e+003
      fB( 5)=1.2345654758418186e+002
      fB( 6)=1.2345654758418186e+002
      fB( 7)=1.1111089918358630e+003
      fB( 8)=3.0864135836408386e+003
      fB( 9)=6.0493709799741046e+003
      fB(10)=1.0000000000000000e+004

      call VSMUL(vec_len,fA,fA,fB1)

      print *,"vsMul test/example program"
      print *,""
      print *,"                  Arguments                           ", &
     &        "      vsMul"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fA(i),fB1(i)
            CurRMS=srelerr(fB(i),fB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14,E25.14)
11    format(A,F25.16)

      end
