!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAbs  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      real(kind=8) dB(10)
      real(kind=8) dB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-1000.0000d+000,1000.0000d+000)
      zA( 2)=(-777.7777d+000,777.7777d+000)
      zA( 3)=(-555.5555d+000,555.5555d+000)
      zA( 4)=(-333.3333d+000,333.3333d+000)
      zA( 5)=(-111.1111d+000,111.1111d+000)
      zA( 6)=(111.1111d+000,-111.1111d+000)
      zA( 7)=(333.3333d+000,-333.3333d+000)
      zA( 8)=(555.5555d+000,-555.5555d+000)
      zA( 9)=(777.7777d+000,-777.7777d+000)
      zA(10)=(1000.0000d+000,-1000.0000)
      dB( 1)=1.4142135623730951d+003
      dB( 2)=1.0999437718513525d+003
      dB( 3)=7.8567412275096603d+002
      dB( 4)=4.7140447365057963d+002
      dB( 5)=1.5713482455019320d+002
      dB( 6)=1.5713482455019320d+002
      dB( 7)=4.7140447365057963d+002
      dB( 8)=7.8567412275096603d+002
      dB( 9)=1.0999437718513525d+003
      dB(10)=1.4142135623730951d+003

      call VZABS(vec_len,zA,dB1)

      print *,"vzAbs test/example program"
      print *,""
      print *,"           Argument                     vzAbs"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",dB1(i)
            CurRMS=drelerr(dB(i),dB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7)
11    format(A,F25.16)

      end
