!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAsin  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-1.0000d+000,1.0000d+000)
      zA( 2)=(-0.7777d+000,0.7777d+000)
      zA( 3)=(-0.5555d+000,0.5555d+000)
      zA( 4)=(-0.3333d+000,0.3333d+000)
      zA( 5)=(-0.1111d+000,0.1111d+000)
      zA( 6)=(0.1111d+000,-0.1111d+000)
      zA( 7)=(0.3333d+000,-0.3333d+000)
      zA( 8)=(0.5555d+000,-0.5555d+000)
      zA( 9)=(0.7777d+000,-0.7777d+000)
      zA(10)=(1.0000d+000,-1.0000d+000)
      zB( 1)=(-6.6623943249251527d-001,1.0612750619050357d+000)
      zB( 2)=(-6.0135587708509519d-001,8.4060455895425301d-001)
      zB( 3)=(-4.8944080432477105d-001,5.9386557353258917d-001)
      zB( 4)=(-3.1990734647712815d-001,3.4427275439844690d-001)
      zB( 5)=(-1.1063788765091863d-001,1.1155195888225219d-001)
      zB( 6)=(1.1063788765091863d-001,-1.1155195888225219d-001)
      zB( 7)=(3.1990734647712815d-001,-3.4427275439844690d-001)
      zB( 8)=(4.8944080432477105d-001,-5.9386557353258917d-001)
      zB( 9)=(6.0135587708509519d-001,-8.4060455895425301d-001)
      zB(10)=(6.6623943249251527d-001,-1.0612750619050357d+000)

      call VZASIN(vec_len,zA,zB1)

      print *,"vzAsin test/example program"
      print *,""
      print *,"           Argument                     vzAsin"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
