!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAsinh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(3.0000d+000,10000.0000d+000)
      zA( 2)=(1113.7777d+000,8889.2222d+000)
      zA( 3)=(2224.5555d+000,7778.4444d+000)
      zA( 4)=(3335.3333d+000,6667.6666d+000)
      zA( 5)=(4446.1111d+000,5556.8888d+000)
      zA( 6)=(5556.8888d+000,4446.1111d+000)
      zA( 7)=(6667.6666d+000,3335.3333d+000)
      zA( 8)=(7778.4444d+000,2224.5555d+000)
      zA( 9)=(8889.2222d+000,1113.7777d+000)
      zA(10)=(10000.0000d+000,3.0000d+000)
      zB( 1)=(9.9034875950361272d+000,1.5704963268023966d+000)
      zB( 2)=(9.7935304892829596d+000,1.4461505920337059d+000)
      zB( 3)=(9.6915674320018415d+000,1.2922419942501833d+000)
      zB( 4)=(9.6098341947868935d+000,1.1069687573846247d+000)
      zB( 5)=(9.5633416390116412d+000,8.9598953878147525d-001)
      zB( 6)=(9.5633416411774572d+000,6.7480677838165393d-001)
      zB( 7)=(9.6098342001817105d+000,4.6382756221178462d-001)
      zB( 8)=(9.6915674384858015d+000,2.7855432850566603d-001)
      zB( 9)=(9.7935304953202280d+000,1.2464573322417867d-001)
      zB(10)=(9.9034876000361258d+000,2.9999998950000077d-004)

      call VZASINH(vec_len,zA,zB1)

      print *,"vzAsinh test/example program"
      print *,""
      print *,"           Argument                     vzAsinh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
