!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcAtanh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(0.7500d+000,0.9000d+000)
      zA( 2)=(0.7666d+000,0.8833d+000)
      zA( 3)=(0.7833d+000,0.8666d+000)
      zA( 4)=(0.8000d+000,0.8500d+000)
      zA( 5)=(0.8166d+000,0.8333d+000)
      zA( 6)=(0.8333d+000,0.8166d+000)
      zA( 7)=(0.8500d+000,0.8000d+000)
      zA( 8)=(0.8666d+000,0.7833d+000)
      zA( 9)=(0.8833d+000,0.7666d+000)
      zA(10)=(0.9000d+000,0.7500d+000)
      zB( 1)=(3.7257322955361039d-001,8.8743011636078650d-001)
      zB( 2)=(3.8548667280375853d-001,8.8805592388369625d-001)
      zB( 3)=(3.9865922482169486d-001,8.8905517994623651d-001)
      zB( 4)=(4.1200697742599235d-001,8.9044257000699012d-001)
      zB( 5)=(4.2558003685990275d-001,8.9211910143550066d-001)
      zB( 6)=(4.3940258266500865d-001,8.9423397552554096d-001)
      zB( 7)=(4.5338331719440389d-001,8.9679874027714557d-001)
      zB( 8)=(4.6758174382061612d-001,8.9971577920437273d-001)
      zB( 9)=(4.8200889769925359d-001,9.0314797406567959d-001)
      zB(10)=(4.9656448002689885d-001,9.0710287418476410d-001)

      call VZATANH(vec_len,zA,zB1)

      print *,"vzAtanh test/example program"
      print *,""
      print *,"           Argument                     vzAtanh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
