!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcCIS  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-10000.0000d+000
      dA( 2)=-7777.7777d+000
      dA( 3)=-5555.5555d+000
      dA( 4)=-3333.3333d+000
      dA( 5)=-1111.1111d+000
      dA( 6)=1111.1111d+000
      dA( 7)=3333.3333d+000
      dA( 8)=5555.5555d+000
      dA( 9)=7777.7777d+000
      dA(10)=10000.0000d+000
      zB( 1)=(-9.5215536825901481d-001,3.0561438888825215d-001)
      zB( 2)=(6.9259906263181004d-001,7.2132276994528466d-001)
      zB( 3)=(3.4393830299014322d-001,-9.3899224902885137d-001)
      zB( 4)=(-9.9464921859866051d-001,1.0330988307550266d-001)
      zB( 5)=(5.2957287328011915d-001,8.4826444690664649d-001)
      zB( 6)=(5.2957287328011915d-001,-8.4826444690664649d-001)
      zB( 7)=(-9.9464921859866051d-001,-1.0330988307550266d-001)
      zB( 8)=(3.4393830299014322d-001,9.3899224902885137d-001)
      zB( 9)=(6.9259906263181004d-001,-7.2132276994528466d-001)
      zB(10)=(-9.5215536825901481d-001,-3.0561438888825215d-001)

      call VZCIS(vec_len,dA,zB1)

      print *,"vzCIS test/example program"
      print *,""
      print *,"   Argument                     vzCIS"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,dA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,A5,E20.10,E20.10)
11    format(A,F25.16)

      end
