!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcExp  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-17.0000d+000,18.0000d+000)
      zA( 2)=(-13.1111d+000,14.1111d+000)
      zA( 3)=(-9.2222d+000,10.2222d+000)
      zA( 4)=(-5.3333d+000,6.3333d+000)
      zA( 5)=(-1.4444d+000,2.4444d+000)
      zA( 6)=(2.4444d+000,-1.4444d+000)
      zA( 7)=(6.3333d+000,-5.3333d+000)
      zA( 8)=(10.2222d+000,-9.2222d+000)
      zA( 9)=(14.1111d+000,-13.1111d+000)
      zA(10)=(18.0000d+000,-17.0000d+000)
      zB( 1)=(2.7336700468037275d-008,-3.1090404292366861d-008)
      zB( 2)=(5.2718434590867303d-008,2.0219669530527123d-006)
      zB( 3)=(-6.9031805334250157d-005,-7.0712150283650660d-005)
      zB( 4)=(4.8220493390719000d-003,2.4185802936554069d-004)
      zB( 5)=(-1.8084266353749434d-001,1.5145585212254198d-001)
      zB( 6)=(1.4526697215961737d+000,-1.1431704865446497d+001)
      zB( 7)=(3.2754677379631244d+002,4.5792469439319871d+002)
      zB( 8)=(-2.6944627012817422d+004,-5.5343007569010069d+003)
      zB( 9)=(1.1494097020286692d+006,-6.9640053097577486d+005)
      zB(10)=(-1.8067216284192696d+007,6.3125329645518661d+007)

      call VZEXP(vec_len,zA,zB1)

      print *,"vzExp test/example program"
      print *,""
      print *,"           Argument                     vzExp"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
