!*******************************************************************************
!                              INTEL CONFIDENTIAL
!  Copyright(C) 2001-2010 Intel Corporation. All Rights Reserved.
!  The source code contained  or  described herein and all documents related to
!  the source code ("Material") are owned by Intel Corporation or its suppliers
!  or licensors.  Title to the  Material remains with  Intel Corporation or its
!  suppliers and licensors. The Material contains trade secrets and proprietary
!  and  confidential  information of  Intel or its suppliers and licensors. The
!  Material  is  protected  by  worldwide  copyright  and trade secret laws and
!  treaty  provisions. No part of the Material may be used, copied, reproduced,
!  modified, published, uploaded, posted, transmitted, distributed or disclosed
!  in any way without Intel's prior express written permission.
!  No license  under any  patent, copyright, trade secret or other intellectual
!  property right is granted to or conferred upon you by disclosure or delivery
!  of the Materials,  either expressly, by implication, inducement, estoppel or
!  otherwise.  Any  license  under  such  intellectual property  rights must be
!  express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!    vcTanh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.fi"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zB1(10)
      real(kind=8) CurRMS,MaxRMS

      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-10.0000d+000,10.0000d+000)
      zA( 2)=(-7.7777d+000,7.7777d+000)
      zA( 3)=(-5.5555d+000,5.5555d+000)
      zA( 4)=(-3.3333d+000,3.3333d+000)
      zA( 5)=(-1.1111d+000,1.1111d+000)
      zA( 6)=(1.1111d+000,-1.1111d+000)
      zA( 7)=(3.3333d+000,-3.3333d+000)
      zA( 8)=(5.5555d+000,-5.5555d+000)
      zA( 9)=(7.7777d+000,-7.7777d+000)
      zA(10)=(10.0000d+000,-10.0000d+000)
      zB( 1)=(-9.9999999831776032d-001,3.7634408149196452d-009)
      zB( 2)=(-1.0000003470018055d+000,5.3354333100097443d-008)
      zB( 3)=(-9.9999655668583243d-001,-2.9694976884679805d-005)
      zB( 4)=(-9.9764171139512925d-001,9.4997704948177541d-004)
      zB( 5)=(-1.1225926239345323d+000,1.9578899279779802d-001)
      zB( 6)=(1.1225926239345323d+000,-1.9578899279779802d-001)
      zB( 7)=(9.9764171139512925d-001,-9.4997704948177541d-004)
      zB( 8)=(9.9999655668583243d-001,2.9694976884679805d-005)
      zB( 9)=(1.0000003470018055d+000,-5.3354333100097443d-008)
      zB(10)=(9.9999999831776032d-001,-3.7634408149196452d-009)

      call VZTANH(vec_len,zA,zB1)

      print *,"vzTanh test/example program"
      print *,""
      print *,"           Argument                     vzTanh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zB1(i)
            CurRMS=zrelerr(zB(i),zB1(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
