!*******************************************************************************
!                              INTEL CONFIDENTIAL
!   Copyright(C) 2005-2010 Intel Corporation. All Rights Reserved.
!   The source code contained  or  described herein and all documents related to
!   the source code ("Material") are owned by Intel Corporation or its suppliers
!   or licensors.  Title to the  Material remains with  Intel Corporation or its
!   suppliers and licensors. The Material contains trade secrets and proprietary
!   and  confidential  information of  Intel or its suppliers and licensors. The
!   Material  is  protected  by  worldwide  copyright  and trade secret laws and
!   treaty  provisions. No part of the Material may be used, copied, reproduced,
!   modified, published, uploaded, posted, transmitted, distributed or disclosed
!   in any way without Intel's prior express written permission.
!   No license  under any  patent, copyright, trade secret or other intellectual
!   property right is granted to or conferred upon you by disclosure or delivery
!   of the Materials,  either expressly, by implication, inducement, estoppel or
!   otherwise.  Any  license  under  such  intellectual property  rights must be
!   express and approved by Intel in writing.
!
!*******************************************************************************
!  Content:
!      F95 interface for BLAS routines
!*******************************************************************************
! This file was generated automatically!
!*******************************************************************************

PURE FUNCTION SDSDOT_F95(SX,SY,SB)
    ! Fortran77 call:
    ! SDSDOT(N,SB,SX,INCX,SY,INCY)
    ! <<< Use statements >>>
    USE F77_BLAS, ONLY: F77_SDOT
    ! <<< ENTRY point >>>
    ENTRY SDSDOT_MKL95(SX,SY,SB)
    ! <<< Implicit statement >>>
    IMPLICIT NONE
    ! <<< Kind parameter >>>
    INTEGER, PARAMETER :: WP = KIND(1.0E0)
    REAL(WP) :: SDSDOT_MKL95
    REAL(WP) :: SDSDOT_F95
    ! <<< Scalar arguments >>>
    REAL(WP), INTENT(IN) :: SB
    ! <<< Array arguments >>>
    REAL(WP), INTENT(IN) :: SX(:)
    REAL(WP), INTENT(IN) :: SY(:)
    ! <<< Local declarations >>>
    ! <<< Parameters >>>
    CHARACTER(LEN=4), PARAMETER :: SRNAME = 'SDOT'
    ! <<< Local scalars >>>
    INTEGER :: INCX
    INTEGER :: INCY
    INTEGER :: N
    ! <<< Intrinsic functions >>>
    INTRINSIC SIZE
    ! <<< Executable statements >>>
    ! <<< Init optional and skipped scalars >>>
    INCX = 1
    INCY = 1
    N = SIZE(SX)
    ! <<< Call blas77 routine >>>
    SDSDOT_F95 = F77_SDOT(N,SB,SX,INCX,SY,INCY)
END FUNCTION SDSDOT_F95
