/******************************************************************************
 *                            INTEL CONFIDENTIAL
 * Copyright(C) 2005-2010 Intel Corporation. All Rights Reserved.
 * The source code contained  or  described herein and all documents related to
 * the source code ("Material") are owned by Intel Corporation or its suppliers
 * or licensors.  Title to the  Material remains with  Intel Corporation or its
 * suppliers and licensors. The Material contains trade secrets and proprietary
 * and  confidential  information of  Intel or its suppliers and licensors. The
 * Material  is  protected  by  worldwide  copyright  and trade secret laws and
 * treaty  provisions. No part of the Material may be used, copied, reproduced,
 * modified, published, uploaded, posted, transmitted, distributed or disclosed
 * in any way without Intel's prior express written permission.
 * No license  under any  patent, copyright, trade secret or other intellectual
 * property right is granted to or conferred upon you by disclosure or delivery
 * of the Materials,  either expressly, by implication, inducement, estoppel or
 * otherwise.  Any  license  under  such  intellectual property  rights must be
 * express and approved by Intel in writing.
 *
 ******************************************************************************
 *
 * dfftw_plan_many_dft_c2r - FFTW3 Fortran 77 wrapper to MKL.
 *
 ******************************************************************************
 */

#include "fftw3_mkl_f77.h"

void
dfftw_plan_many_dft_c2r(PLAN *p, INTEGER *rank, INTEGER *n, INTEGER *howmany,
                        COMPLEX16 *in, INTEGER *inembed, INTEGER *istride,
                        INTEGER *idist, REAL8 *out, INTEGER *onembed,
                        INTEGER *ostride, INTEGER *odist, INTEGER *flags)
{
    INTEGER one = 1;
    INTEGER is[MKL_MAXRANK];
    INTEGER os[MKL_MAXRANK];
    INTEGER i;

    if (*rank > MKL_MAXRANK)
    {
        *(fftw_plan *)p = NULL;
        return;
    }

    for (i = 0; i < *rank; i++)
    {
        if (i == 0)
        {
            is[i] = *istride;
            os[i] = *ostride;
        }
        else
        {
            is[i] = inembed[i - 1] * is[i - 1];
            os[i] = onembed[i - 1] * os[i - 1];
        }
    }
    dfftw_plan_guru_dft_c2r(p, rank, n, is, os, &one, howmany, idist, odist,
                            in, out, flags);
}
