/******************************************************************************
 *                            INTEL CONFIDENTIAL
 * Copyright(C) 2005-2010 Intel Corporation. All Rights Reserved.
 * The source code contained  or  described herein and all documents related to
 * the source code ("Material") are owned by Intel Corporation or its suppliers
 * or licensors.  Title to the  Material remains with  Intel Corporation or its
 * suppliers and licensors. The Material contains trade secrets and proprietary
 * and  confidential  information of  Intel or its suppliers and licensors. The
 * Material  is  protected  by  worldwide  copyright  and trade secret laws and
 * treaty  provisions. No part of the Material may be used, copied, reproduced,
 * modified, published, uploaded, posted, transmitted, distributed or disclosed
 * in any way without Intel's prior express written permission.
 * No license  under any  patent, copyright, trade secret or other intellectual
 * property right is granted to or conferred upon you by disclosure or delivery
 * of the Materials,  either expressly, by implication, inducement, estoppel or
 * otherwise.  Any  license  under  such  intellectual property  rights must be
 * express and approved by Intel in writing.
 *
 ******************************************************************************
 *
 * sfftw_plan_guru_split_dft_c2r - FFTW3 Fortran 77 wrapper to MKL.
 *
 ******************************************************************************
 */

#include "fftw3_mkl_f77.h"

void
sfftw_plan_guru_split_dft_c2r(PLAN *p, INTEGER *rank, INTEGER *n, INTEGER *is,
                              INTEGER *os, INTEGER *howmany_rank,
                              INTEGER *howmany_n, INTEGER *howmany_is,
                              INTEGER *howmany_os, REAL4 *ri, REAL4 *ii,
                              REAL4 *out, INTEGER *flags)
{
    fftwf_iodim64 dims64[MKL_MAXRANK];
    fftwf_iodim64 howmany_dims64[MKL_ONE];
    int i;

    if (*rank > MKL_MAXRANK || *howmany_rank > MKL_ONE)
    {
        *(fftwf_plan *)p = NULL;
        return;
    }

    for (i = 0; i < *rank; ++i)
    {
        dims64[i].n = n[*rank - i - 1];
        dims64[i].is = is[*rank - i - 1];
        dims64[i].os = os[*rank - i - 1];
    }
    for (i = 0; i < *howmany_rank; ++i)
    {
        howmany_dims64[i].n = howmany_n[*rank - i - 1];
        howmany_dims64[i].is = howmany_is[*rank - i - 1];
        howmany_dims64[i].os = howmany_os[*rank - i - 1];
    }
    *(fftwf_plan *)p =
        fftwf_plan_guru64_split_dft_c2r(*rank, dims64, *howmany_rank,
                                       howmany_dims64, ri, ii, out, *flags);
}
